/*
 * Copyright (C) 2013 Darth Affe <http://wyrez.org> and contributors
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package org.wyrez.shootingstars.controls;

import com.jme3.math.Vector3f;
import com.jme3.renderer.Camera;
import com.jme3.scene.Spatial;
import com.jme3.scene.control.Control;
import org.wyrez.shootingstars.helper.UserDataKeys;

/**
 *
 * @author Darth Affe
 */
public class PlayerCamControl extends BaseControl {

    private Camera camera;

    public PlayerCamControl(Camera camera) {
        this.camera = camera;
    }

    @Override
    public void update(float tpf) {
        if (spatial.getUserData(UserDataKeys.RUNNING)) {
            camera.setLocation(spatial.getLocalTranslation()/*.add(new Vector3f(10f, 10f, 0f))*/);
            camera.lookAt(spatial.getLocalTranslation(), Vector3f.UNIT_Y);
            camera.setRotation(spatial.getLocalRotation());
        }
    }

    public Control cloneForSpatial(Spatial spatial) {
        PlayerCamControl control = new PlayerCamControl(camera);
        control.setSpatial(spatial);
        return control;
    }
}
